#include <Practicum.h>

extern "C" {
#include "usbdrv.h"
}


#define RQ_GET_SWITCH_BOARD1 0
#define RQ_GET_SWITCH_BOARD2 1


//////////////////////////////////////////////////////////////////////
usbMsgLen_t usbFunctionSetup(uint8_t data[8])
{
  usbRequest_t *rq = (usbRequest_t*)data;
  static uint8_t switch_state;  /* must stay when usbFunctionSetup returns */
  int a = 0,b = 0,c = 0,d = 0;

  if (rq->bRequest == RQ_GET_SWITCH_BOARD1)
  {
    a = digitalRead(PIN_PC0) == LOW ? 1:0;
    b = digitalRead(PIN_PC1) == LOW ? 1:0;
    c = digitalRead(PIN_PC2) == LOW ? 1:0;
    d = digitalRead(PIN_PC3) == LOW ? 1:0;
    
    switch_state = a + b*2 + c*4 + d*8;
    /* point usbMsgPtr to the data to be returned to host */
    usbMsgPtr = (uint8_t*) &switch_state;

    /* return the number of bytes of data to be returned to host */
    return sizeof(switch_state);
  }
  
  return 0;
}

//////////////////////////////////////////////////////////////////////
void setup()
{
    
    pinMode(PIN_PC0, INPUT_PULLUP);
    pinMode(PIN_PC1, INPUT_PULLUP);
    pinMode(PIN_PC2, INPUT_PULLUP);
    pinMode(PIN_PC3, INPUT_PULLUP);

    usbInit();

    /* enforce re-enumeration of USB devices */
    usbDeviceDisconnect();
    delay(300);
    usbDeviceConnect();
}

//////////////////////////////////////////////////////////////////////
void loop()
{
  usbPoll();
}
